IF EXISTS (SELECT * FROM dbo.SysObjects WHERE id = object_id(N'dbo.AUDIT_upd_RateLevelRoomTypeRestrictionXTab') AND OBJECTPROPERTY(id, N'IsTrigger') = 1) DROP TRIGGER dbo.AUDIT_upd_RateLevelRoomTypeRestrictionXTab 
GO
CREATE TRIGGER [dbo].[AUDIT_upd_RateLevelRoomTypeRestrictionXTab]
ON [dbo].[RateLevelRoomTypeRestrictionXTab] FOR UPDATE NOT FOR REPLICATION AS
BEGIN
	

	DECLARE 
		@IDENTITY_SAVE			varchar(50),
		@AUDIT_LOG_TRANSACTION_ID	Int,
		@PRIM_KEY			nvarchar(4000),
		@Inserted	    		bit,
 		@ROWS_COUNT				int,
		@FK_UserIdNumber INT,
		@FK_CashBox INT,
		@ProgramPart SMALLINT,
		@TerminalName VARCHAR(50),
		@SystemDateStr VARCHAR(8),
		@SystemDateTime DATETIME

	SET NOCOUNT ON

	Select @ROWS_COUNT=count(*) from inserted
	SET @IDENTITY_SAVE = CAST(IsNull(@@IDENTITY,1) AS varchar(50))

    SELECT TOP 1 @FK_UserIdNumber = FK_UserIdNumber,
	@FK_CashBox = FK_CashBox,
	@ProgramPart = ProgramPart,
	@TerminalName = TerminalName
	FROM PersonnelLogInfo WITH (NOLOCK)
	WHERE spid = @@spid 
	ORDER BY CreateDate DESC

	IF ISNULL(@FK_UserIdNumber, 0) = 0
	  SET @FK_UserIdNumber = 1
	IF ISNULL(@FK_CashBox, -1) <= 0
	  SET @FK_CashBox = -1
	IF ISNULL(@ProgramPart, -1) <= 0
	  SET @ProgramPart = 14 -- ppUnknown from SystemAll
	IF ISNULL(@TerminalName, '') = ''
	  SET @TerminalName = 'Unknown'

    SELECT @SystemDateStr = SystemDate FROM System WITH (NOLOCK) WHERE Number = 1
    SET @SystemDateTime = CONVERT(DATETIME, @SystemDateStr + ' ' + CONVERT(CHAR(8), CURRENT_TIMESTAMP, 108))

	INSERT INTO dbo.AUDIT_LOG_TRANSACTIONS
	(
		TABLE_NAME,
		TABLE_SCHEMA,
		AUDIT_ACTION_ID,
		HOST_NAME,
		APP_NAME,
		MODIFIED_BY,
		MODIFIED_DATE,
		AFFECTED_ROWS,
		FK_UserIdNumber,
		FK_CashBox,
		ProgramPart,
		TerminalName,
		RealDateTime
	)
	values(
		'RateLevelRoomTypeRestrictionXTab',
		'dbo',
		1,	--	ACTION ID For UPDATE
		CASE 
		  WHEN LEN(HOST_NAME()) < 1 THEN ' '
		  ELSE HOST_NAME()
		END,
		CASE 
		  WHEN LEN(APP_NAME()) < 1 THEN ' '
		  ELSE APP_NAME()
		END,
		SUSER_SNAME(),
		@SystemDateTime,
		@ROWS_COUNT,
		@FK_UserIdNumber,
		@FK_CashBox,
		@ProgramPart,
		@TerminalName,
		GETDATE()
	)	
	
	Set @AUDIT_LOG_TRANSACTION_ID = SCOPE_IDENTITY()
	
	SET @Inserted = 0
	
	If UPDATE([FKRateLevelRoomTypeXTabId])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[FKRateLevelRoomTypeXTabId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRoomTypeXTabId], NEW.[FKRateLevelRoomTypeXTabId]), 0), '[FKRateLevelRoomTypeXTabId] Is Null')+' AND '+IsNull('[FKRateLevelRestrictionId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRestrictionId], NEW.[FKRateLevelRestrictionId]), 0), '[FKRateLevelRestrictionId] Is Null')+' AND '+IsNull('[DateStamp]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DateStamp], NEW.[DateStamp]), 121),'''' ,'''''')+'''', '[DateStamp] Is Null')),
		    'FKRateLevelRoomTypeXTabId',
			CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0),
			CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DateStamp], 121)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DateStamp], 121)))
			
		FROM deleted OLD Full Outer Join inserted NEW On
			(CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0) or (NEW.[FKRateLevelRoomTypeXTabId] Is Null and OLD.[FKRateLevelRoomTypeXTabId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0) or (NEW.[FKRateLevelRestrictionId] Is Null and OLD.[FKRateLevelRestrictionId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[DateStamp], 121)=CONVERT(nvarchar(4000), OLD.[DateStamp], 121) or (NEW.[DateStamp] Is Null and OLD.[DateStamp] Is Null))
			WHERE (
			
			
				(
					NEW.[FKRateLevelRoomTypeXTabId] <>
					OLD.[FKRateLevelRoomTypeXTabId]
				) Or
			
				(
					NEW.[FKRateLevelRoomTypeXTabId] Is Null And
					OLD.[FKRateLevelRoomTypeXTabId] Is Not Null
				) Or
				(
					NEW.[FKRateLevelRoomTypeXTabId] Is Not Null And
					OLD.[FKRateLevelRoomTypeXTabId] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([FKRateLevelRestrictionId])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[FKRateLevelRoomTypeXTabId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRoomTypeXTabId], NEW.[FKRateLevelRoomTypeXTabId]), 0), '[FKRateLevelRoomTypeXTabId] Is Null')+' AND '+IsNull('[FKRateLevelRestrictionId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRestrictionId], NEW.[FKRateLevelRestrictionId]), 0), '[FKRateLevelRestrictionId] Is Null')+' AND '+IsNull('[DateStamp]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DateStamp], NEW.[DateStamp]), 121),'''' ,'''''')+'''', '[DateStamp] Is Null')),
		    'FKRateLevelRestrictionId',
			CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0),
			CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DateStamp], 121)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DateStamp], 121)))
			
		FROM deleted OLD Full Outer Join inserted NEW On
			(CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0) or (NEW.[FKRateLevelRoomTypeXTabId] Is Null and OLD.[FKRateLevelRoomTypeXTabId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0) or (NEW.[FKRateLevelRestrictionId] Is Null and OLD.[FKRateLevelRestrictionId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[DateStamp], 121)=CONVERT(nvarchar(4000), OLD.[DateStamp], 121) or (NEW.[DateStamp] Is Null and OLD.[DateStamp] Is Null))
			WHERE (
			
			
				(
					NEW.[FKRateLevelRestrictionId] <>
					OLD.[FKRateLevelRestrictionId]
				) Or
			
				(
					NEW.[FKRateLevelRestrictionId] Is Null And
					OLD.[FKRateLevelRestrictionId] Is Not Null
				) Or
				(
					NEW.[FKRateLevelRestrictionId] Is Not Null And
					OLD.[FKRateLevelRestrictionId] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([DateStamp])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[FKRateLevelRoomTypeXTabId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRoomTypeXTabId], NEW.[FKRateLevelRoomTypeXTabId]), 0), '[FKRateLevelRoomTypeXTabId] Is Null')+' AND '+IsNull('[FKRateLevelRestrictionId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRestrictionId], NEW.[FKRateLevelRestrictionId]), 0), '[FKRateLevelRestrictionId] Is Null')+' AND '+IsNull('[DateStamp]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DateStamp], NEW.[DateStamp]), 121),'''' ,'''''')+'''', '[DateStamp] Is Null')),
		    'DateStamp',
			CONVERT(nvarchar(4000), OLD.[DateStamp], 121),
			CONVERT(nvarchar(4000), NEW.[DateStamp], 121),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DateStamp], 121)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DateStamp], 121)))
			
		FROM deleted OLD Full Outer Join inserted NEW On
			(CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0) or (NEW.[FKRateLevelRoomTypeXTabId] Is Null and OLD.[FKRateLevelRoomTypeXTabId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0) or (NEW.[FKRateLevelRestrictionId] Is Null and OLD.[FKRateLevelRestrictionId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[DateStamp], 121)=CONVERT(nvarchar(4000), OLD.[DateStamp], 121) or (NEW.[DateStamp] Is Null and OLD.[DateStamp] Is Null))
			WHERE (
			
			
				(
					NEW.[DateStamp] <>
					OLD.[DateStamp]
				) Or
			
				(
					NEW.[DateStamp] Is Null And
					OLD.[DateStamp] Is Not Null
				) Or
				(
					NEW.[DateStamp] Is Not Null And
					OLD.[DateStamp] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([RestrictionLength])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[FKRateLevelRoomTypeXTabId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRoomTypeXTabId], NEW.[FKRateLevelRoomTypeXTabId]), 0), '[FKRateLevelRoomTypeXTabId] Is Null')+' AND '+IsNull('[FKRateLevelRestrictionId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRestrictionId], NEW.[FKRateLevelRestrictionId]), 0), '[FKRateLevelRestrictionId] Is Null')+' AND '+IsNull('[DateStamp]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DateStamp], NEW.[DateStamp]), 121),'''' ,'''''')+'''', '[DateStamp] Is Null')),
		    'RestrictionLength',
			CONVERT(nvarchar(4000), OLD.[RestrictionLength], 0),
			CONVERT(nvarchar(4000), NEW.[RestrictionLength], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DateStamp], 121)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DateStamp], 121)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0) or (NEW.[FKRateLevelRoomTypeXTabId] Is Null and OLD.[FKRateLevelRoomTypeXTabId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0) or (NEW.[FKRateLevelRestrictionId] Is Null and OLD.[FKRateLevelRestrictionId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[DateStamp], 121)=CONVERT(nvarchar(4000), OLD.[DateStamp], 121) or (NEW.[DateStamp] Is Null and OLD.[DateStamp] Is Null))
			where (
			
			
				(
					NEW.[RestrictionLength] <>
					OLD.[RestrictionLength]
				) Or
			
				(
					NEW.[RestrictionLength] Is Null And
					OLD.[RestrictionLength] Is Not Null
				) Or
				(
					NEW.[RestrictionLength] Is Not Null And
					OLD.[RestrictionLength] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([RoomsAllocated])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[FKRateLevelRoomTypeXTabId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRoomTypeXTabId], NEW.[FKRateLevelRoomTypeXTabId]), 0), '[FKRateLevelRoomTypeXTabId] Is Null')+' AND '+IsNull('[FKRateLevelRestrictionId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRestrictionId], NEW.[FKRateLevelRestrictionId]), 0), '[FKRateLevelRestrictionId] Is Null')+' AND '+IsNull('[DateStamp]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DateStamp], NEW.[DateStamp]), 121),'''' ,'''''')+'''', '[DateStamp] Is Null')),
		    'RoomsAllocated',
			CONVERT(nvarchar(4000), OLD.[RoomsAllocated], 0),
			CONVERT(nvarchar(4000), NEW.[RoomsAllocated], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DateStamp], 121)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DateStamp], 121)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0) or (NEW.[FKRateLevelRoomTypeXTabId] Is Null and OLD.[FKRateLevelRoomTypeXTabId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0) or (NEW.[FKRateLevelRestrictionId] Is Null and OLD.[FKRateLevelRestrictionId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[DateStamp], 121)=CONVERT(nvarchar(4000), OLD.[DateStamp], 121) or (NEW.[DateStamp] Is Null and OLD.[DateStamp] Is Null))
			where (
			
			
				(
					NEW.[RoomsAllocated] <>
					OLD.[RoomsAllocated]
				) Or
			
				(
					NEW.[RoomsAllocated] Is Null And
					OLD.[RoomsAllocated] Is Not Null
				) Or
				(
					NEW.[RoomsAllocated] Is Not Null And
					OLD.[RoomsAllocated] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([RoomsAvailableRoomType])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[FKRateLevelRoomTypeXTabId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRoomTypeXTabId], NEW.[FKRateLevelRoomTypeXTabId]), 0), '[FKRateLevelRoomTypeXTabId] Is Null')+' AND '+IsNull('[FKRateLevelRestrictionId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRestrictionId], NEW.[FKRateLevelRestrictionId]), 0), '[FKRateLevelRestrictionId] Is Null')+' AND '+IsNull('[DateStamp]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DateStamp], NEW.[DateStamp]), 121),'''' ,'''''')+'''', '[DateStamp] Is Null')),
		    'RoomsAvailableRoomType',
			CONVERT(nvarchar(4000), OLD.[RoomsAvailableRoomType], 0),
			CONVERT(nvarchar(4000), NEW.[RoomsAvailableRoomType], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DateStamp], 121)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DateStamp], 121)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0) or (NEW.[FKRateLevelRoomTypeXTabId] Is Null and OLD.[FKRateLevelRoomTypeXTabId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0) or (NEW.[FKRateLevelRestrictionId] Is Null and OLD.[FKRateLevelRestrictionId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[DateStamp], 121)=CONVERT(nvarchar(4000), OLD.[DateStamp], 121) or (NEW.[DateStamp] Is Null and OLD.[DateStamp] Is Null))
			where (
			
			
				(
					NEW.[RoomsAvailableRoomType] <>
					OLD.[RoomsAvailableRoomType]
				) Or
			
				(
					NEW.[RoomsAvailableRoomType] Is Null And
					OLD.[RoomsAvailableRoomType] Is Not Null
				) Or
				(
					NEW.[RoomsAvailableRoomType] Is Not Null And
					OLD.[RoomsAvailableRoomType] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([RoomsAvailableTotal])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[FKRateLevelRoomTypeXTabId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRoomTypeXTabId], NEW.[FKRateLevelRoomTypeXTabId]), 0), '[FKRateLevelRoomTypeXTabId] Is Null')+' AND '+IsNull('[FKRateLevelRestrictionId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelRestrictionId], NEW.[FKRateLevelRestrictionId]), 0), '[FKRateLevelRestrictionId] Is Null')+' AND '+IsNull('[DateStamp]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DateStamp], NEW.[DateStamp]), 121),'''' ,'''''')+'''', '[DateStamp] Is Null')),
		    'RoomsAvailableTotal',
			CONVERT(nvarchar(4000), OLD.[RoomsAvailableTotal], 0),
			CONVERT(nvarchar(4000), NEW.[RoomsAvailableTotal], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DateStamp], 121)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DateStamp], 121)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[FKRateLevelRoomTypeXTabId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRoomTypeXTabId], 0) or (NEW.[FKRateLevelRoomTypeXTabId] Is Null and OLD.[FKRateLevelRoomTypeXTabId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelRestrictionId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelRestrictionId], 0) or (NEW.[FKRateLevelRestrictionId] Is Null and OLD.[FKRateLevelRestrictionId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[DateStamp], 121)=CONVERT(nvarchar(4000), OLD.[DateStamp], 121) or (NEW.[DateStamp] Is Null and OLD.[DateStamp] Is Null))
			where (
			
			
				(
					NEW.[RoomsAvailableTotal] <>
					OLD.[RoomsAvailableTotal]
				) Or
			
				(
					NEW.[RoomsAvailableTotal] Is Null And
					OLD.[RoomsAvailableTotal] Is Not Null
				) Or
				(
					NEW.[RoomsAvailableTotal] Is Not Null And
					OLD.[RoomsAvailableTotal] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	-- Watch
	
	-- Lookup
	
	IF @Inserted = 0
	BEGIN
		DELETE FROM dbo.AUDIT_LOG_TRANSACTIONS WHERE AUDIT_LOG_TRANSACTION_ID = @AUDIT_LOG_TRANSACTION_ID
	END
	-- Restore @@IDENTITY Value  
    DECLARE @maxprec AS varchar(2)
    SET @maxprec=CAST(@@MAX_PRECISION as varchar(2))
    EXEC('SELECT IDENTITY(decimal('+@maxprec+',0),'+@IDENTITY_SAVE+',1) id INTO #tmp')
End
